﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace CorsServer.WebApi31
{
    public class CorsOption
    {
        /// <summary>
        /// 允许跨域的请求来源
        /// </summary>
        public List<string> Origins { get; set; }

        /// <summary>
        /// 允许跨域的HTTP方法
        /// </summary>
        public List<string> Methods { get; set; }

        /// <summary>
        /// 允许跨域的HTTP请求头
        /// </summary>
        public List<string> Headers { get; set; }

        /// <summary>
        /// 公开的非简单响应标头
        /// </summary>
        public List<string> ExposedHeaders { get; set; }

        /// <summary>
        /// 允许跨域请求中的凭据
        /// </summary>
        public bool AllowCredentials { get; set; }

        /// <summary>
        /// 预检过期时间
        /// </summary>
        public TimeSpan PreflightMaxAge { get; set; }
    }
}
